-module(ebb_prim).
-export([task/2, task/1, return/1,
	 func/1, app/2, dynamic/1,
	 ignore/1, nop/0, id/0]).

task(Func, Arg) ->
    app(dynamic(Func), return(Arg)).

task(Thunk) ->
    V = flow_graph:void(),
    D = flow_graph:delayed(),
    flow_graph:from_list(V, D, [flow_graph:dynamic(V, D, Thunk)]).

return(Val) ->
    flow_graph:singleton(flow_graph:value(Val)).

func(Func) ->
    In = flow_graph:hole(),
    Out = flow_graph:hole(),
    flow_graph:from_list(In, Out, [flow_graph:func(In, Out, Func)]).

app(Op, Arg) ->
    flow_graph:append(flow_graph:singleton(flow_graph:value(Arg)), Op).

dynamic(FuncT) ->
    In = flow_graph:hole(),
    D = flow_graph:delayed(),
    flow_graph:from_list(In, D, [flow_graph:dynamic(In, D, FuncT)]).

ignore(Task) ->
    H = flow_graph:hole(),
    V = flow_graph:void(),
    I = flow_graph:from_list(H, V, [flow_graph:flow(H, V)]),
    flow_graph:append(I, Task).

nop() ->
    flow_graph:singleton(flow_graph:value('nop')).

id() ->
    flow_graph:singleton(flow_graph:hole()).
